# <center>CSP2020 信心赛</center>

<center>出题学校：大连24中</center>

|      题目名称       |     宝藏     | 寻找道路 |   猪国杀   |   数树    |
| :-----------------: | :----------: | :------: | :--------: | :-------: |
|      题目类型       |    传统型    |  传统型  |   传统型   |  传统型   |
|      试题名称       |   treasure   |   path   |   legend   |   count   |
|     提交程序名      | treasure.cpp | path.cpp | legend.cpp | count.cpp |
|     输入文件名      | treasure.in  | path.in  | legend.in  | count.in  |
|     输出文件名      | treasure.out | path.out | legend.out | count.out |
|   每个测试点时限    |     1.0s     |   1.5s   |    1.0s    |   1.0s    |
|      空间限制       |    512MB     |  512MB   |   512MB    |   512MB   |
| 是否有Special Judge |      否      |    否    |     否     |    否     |

注意事项

1. **提交文件请对每道题目分别<font color=red>建立子文件夹</font>，仅支持C++语言，编译命令为-O2 -std=c++11。**
2. 程序可使用的栈空间大小与该题内存空间限制一致。
3. 文件名必须使用英文小写。
4. 每题的时间限制均至少为标准程序在与评测相同的环境下最慢运行时间的$2$倍。
5. 题目难度和顺序无直接关系。
6. 比赛时间为$4$小时。
7. 由于出题人水平很低且是第一次尝试出题，题目质量可能较低，欢迎大家来D出题人。
8. 如果出现数据出锅/标程不为最优解等问题，也欢迎大家来D出题人，QQ：352912432。
9. 最终评测配置为：Intel(R) Core(TM) i5-7400T CPU @ 2.40GHz，内存 8GB​。
10. 评测系统为 Ubuntu 18.04.5 LTS，编译器版本为 G++ 7.5.0，使用 LemonLime 评测。

<div STYLE="page-break-after: always;"></div>

## <center>宝藏(treasure)</center>

#### 题目描述

参与考古挖掘的小明得到了一份藏宝图，藏宝图上标出了$n$个深埋在地下的宝藏，第$i$个宝藏价值为$w_i$，挖掘它需要时间$t_i$。

赞助商给小明的时间是有限的，他只有$T$的时间用来挖掘宝藏。也就是说他挖掘的宝藏消耗的总时间不得超过$T$。

现在小明一共进行了$Q$次开采活动，第$i$次开采正好开采$x_i$个宝藏**（保证$x_i$为奇数）**，他想要您计算开采的宝藏的价值的中位数最大是多少。**（这些开采活动是独立的，即不会实际对宝藏造成影响）**

#### 输入格式

第一行三个用空格分离的正整数$n,T,Q$，代表宝藏的个数，小明的时间以及询问次数。

接下来$n$行，每行有两个用空格分开的整数$w_i,t_i$。

接下来$Q$行，每行一个整数$x_i$表示第$i$次开采的宝藏数。

#### 输出格式

输出$Q$行，每行一个整数表示答案，**如果不存在任何方案请输出$-1$。**

#### 样例一输入

```
5 80 3
23 24
37 33
24 22
29 18
57 20
1
3
5
```

#### 样例一输出

```
57
37
-1
```

#### 样例二

见下发文件中的`treasure/treasure2.in`和`treasure/treasure2.out`

#### 数据范围与约定

本题采用子任务捆绑测试。对于每个子任务，你只有通过了这个子任务的所有数据，才能获得这个子任务的分数。

对于所有的数据，满足$n,Q\leq 3\times 10^5\ \ 0\leq w_i,t_i\leq 10^6\ \ 0\leq T\leq 10^{11} \ \ x_i\leq n$。


 - 子任务$1$（$2$0分）：$n \leq 2000\ \ Q=1$
 - 子任务$2$（$20$分）：$n \leq 2000$
 - 子任务$3$（$30$分）：$Q=1 $
 - 子任务$4$（$30$分）：没有额外的限制

<div STYLE="page-break-after: always;"></div>

## <center>寻找道路(path)</center>

#### 题目描述

给一个$n$个点$m$条有向边的图，每条边上有数字$0$或$1$，定义一个路径的长度为这个路径上依次经过的边上的数字拼在一起后在二进制下的值（前导$0$对该路径长度没有贡献）。现在需要你求出从$1$号点出发，到$2\cdots n$号点的路径的长度的最小值。

#### 输入格式

第一行两个整数$n,m$。

接下来$m$行，每行三个整数$u,v,w$表示一条从$u$到$v$的有向边，这条边上的数字是$w$。

#### 输出格式

输出一行$n-1$个用空格隔开的整数，第$i$个为从$1$号点出发，到$i+1$号点的路径的长度的最小值。**对$10^9+7$取模，如果不存在路径，请输出$-1$。**

#### 样例一输入

```
7 13
4 4 1
2 3 1
7 3 0
2 7 0
3 6 0
1 7 1
7 3 0
1 6 1
1 2 1
5 4 1
6 1 1
5 1 0
4 4 1
```

#### 样例一输出

```
1 2 -1 -1 1 1
```

#### 样例二

见下发文件中的`path/path2.in`和`path/path2.out`

#### 数据范围与约定

本题采用子任务捆绑测试。对于每个子任务，你只有通过了这个子任务的所有数据，才能获得这个子任务的分数。

对于所有的数据，满足$2\leq n\leq 10^6\ \ m\leq 2\times 10^6$。


 - 子任务$1$（$2$0分）：$n \leq 5 \ \ m\leq 10$
 - 子任务$2$（$30$分）：$n \leq 1000 \ \ m \leq 2000$
 - 子任务$3$（$30$分）：$n\leq 10^5 \ \ m \leq 2\times 10^5$
 - 子任务$4$（$20$分）：没有额外的限制

<div STYLE="page-break-after: always;"></div>

## <center>猪国杀(legend)</center>

#### 题目描述

《猪国杀》是一款热门的桌上游戏，该游戏以身份、势力或阵营等为线索，以卡牌为形式，合纵连横，经过一轮一轮的谋略和动作获得最终的胜利。《猪国杀》集合历史、文学、美术等元素于一身，在OI界广受欢迎。

在《猪国杀》游戏中，牌堆中牌的数量是无穷大的，并且每一张牌的点数都是在$[1,A]$内均匀随机的正整数。

游戏中有多种武将，每个武将有其独特的技能，其中一个技能描述如下：

> **称猪**：每当你受到一次伤害后，你可以亮出牌堆顶的$n$张牌。然后获得其中任意数量点数之和不大于$m$的牌，将其余的牌置入弃牌堆。

现在询问如果“称猪”时总是获得尽量多的牌，那么单次发动“称猪”期望能获得几张牌。

#### 输入格式

一行三个整数$n,m,A$。

#### 输出格式

输出一行一个整数表示答案，**对998244353取模。**

#### 样例一输入

```
4 12 13
```

#### 样例一输出

```
844808106
```

#### 样例二输入

```
4 13 13
```

#### 样例二输出

```
76298711
```

#### 样例三输入

```
48 47 22
```

#### 样例三输出

```
127439024
```

#### 数据范围与约定

本题采用子任务捆绑测试。对于每个子任务，你只有通过了这个子任务的所有数据，才能获得这个子任务的分数。

对于所有的数据，满足$1\leq n\leq 100\ \ 1\leq m,A\leq 1000$。

 - 子任务$1$（$2$0分）：$n,m,A\leq 5$
 - 子任务$2$（$20$分）：$n,m,A\leq 50$
 - 子任务$3$（$20$分）：$n\leq 5$
 - 子任务$4$（$20$分）：$m,A\leq 5$
 - 子任务$5$（$20$分）：没有额外的限制

<div STYLE="page-break-after: always;"></div>

## <center>数树(count)</center>

#### 题目描述

给定两颗树$T1,T2$，求$T1$有多少个连通块与$T2$同构。

树$A$与树$B$同构当且仅当存在一个$A$的点集到$B$的点集的双射$f$，且存在一个$A$的边集到$B$的边集的双射$g$将边$(x,y)$映射到边$(f(x),f(y))$。换一种说法，即存在一种将$A$重标号的方案使得$A$与$B$完全相同。


#### 输入格式

第一行一个整数$n$表示$T1$的点数。

接下来$n-1$行每行两个整数描述$T1$中的一条边。

接下来一行一个整数$m$表示$T2$的点数。

之后$m-1$行每行两个整数描述$T2$中的一条边。


#### 输出格式

输出一行一个整数表示答案，**对998244353取模。**

#### 样例一输入

```
9
2 4
5 2
1 8
4 8
9 3
3 5
7 9
2 6
5
2 3
1 3
5 1
4 1
```

#### 样例一输出

```
2
```

#### 样例二

见下发文件中的`count/count2.in`和`count/count2.out`

#### 数据范围与约定

本题采用子任务捆绑测试。对于每个子任务，你只有通过了这个子任务的所有数据，才能获得这个子任务的分数。

对于所有的数据，满足$n\leq 3000\ \ m\leq 10$。

 - 子任务$1$（$2$0分）：$n,m\leq 10$
 - 子任务$2$（$20$分）：$n \leq 50$
 - 子任务$3$（$10$分）：$T2$是一条链
 - 子任务$4$（$10$分）：$T2$中所有边都有一端是$1$号点
 - 子任务$5$（$40$分）：没有额外的限制